/*******************************************************************************
  InetPowerServer/2 - Rexx startup script

  This script is the correct way to start IPS to with
*******************************************************************************/
parse arg par1 trash;

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs';
call SysLoadFuncs;

if ( par1 = 'DoStartup' ) then do
  do until ( rc = 0 )
    '@bin\ips2 mkhistory';
    if ( stream( 'bin\history.cmd', 'c', 'query exist' ) <> '' )  then do
      '@'value( 'COMSPEC',,'OS2ENVIRONMENT' )' /C bin\history.cmd >log\history.log';
    end;

    if ( stream( 'bin\ips2upd.exe', 'c', 'query exist' ) <> '' )  then do
      call LogIt 'New IPS executable found, testing file';
      '@bin\ips2upd checkexe';
      if ( rc = -1 ) then do
	call LogIt 'New file was ok, upgrading';
        '@COPY bin\ips2.exe bin\ips2old.exe >>log\upgrade.log';
        '@COPY bin\ips2upd.exe bin\ips2.exe >>log\upgrade.log';
        '@DEL  bin\ips2upd.exe >>log\upgrade.log';
      end
      else
        call LogIt 'New file was corrupt, not upgrading' ;
    end;

    '@bin\ips2';
    err = rc;
    if ( err > 0 ) then do
      call LogIt 'Error #'rc', restarting IPS';
    end;
  end;

  return 0;
end;

'@START "InetPowerServer/2" /C /MIN bin\startos2.cmd DoStartup';
say;
say 'Starting InetPowerServer/2 minimized ...';
return 0;

LogIt:
parse arg logtxt;

log = 'log\ips.log';
rc = stream( log, 'c', 'open' );
rc = stream( log, 'c', 'seek <0' );
dt = ' 'substr( time( 'L' ), 1, 8 )','substr( time( 'L' ), 10, 2 );
call lineout log, dt' 'logtxt;
rc = stream( log, 'c', 'close' );

return;
