/* InetPowerServer/2 Installation Script */
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

ipsvers = 'InetPowerServer/2'
cur_dir = directory()

say 'Checking directory structure:'
if ( SysFileTree( '.\cfg', ft ) = 0 ) then
  if ( ft.0 = 0 ) then do
    if ( SysMkDir( 'cfg' ) = 0 ) then do
      say '- cfg\ subdirectory created'
      '@xcopy .\doc\cfg\* .\cfg\* /e /s >NUL'
      say '- example setup copied from .\doc\cfg'
    end
    else
      say 'X cfg\ subdirectory cannot be created'
  end
  else
  do
    '@xcopy .\doc\cfg\ips* .\cfg >NUL'
    say '- new language files copied from .\doc\cfg'
  end

if ( SysFileTree( '.\scr', ft ) = 0 ) then 
  if ( ft.0 = 0 ) then do
    if ( SysMkDir( 'scr' ) = 0 ) then do
      say '- scr\ subdirectory created'
      '@xcopy .\doc\scr\* .\scr\* /s >NUL'
      say '- example RexxHook scripts copied from .\doc\scr'
    end
    else
      say 'X scr\ subdirectory cannot be created'
  end

if ( SysFileTree( '.\msg', ft ) = 0 ) then 
  if ( ft.0 = 0 ) then do
    if ( SysMkDir( 'msg' ) = 0 ) then do
      say '- msg\ subdirectory created'
      '@xcopy .\doc\msg\* .\msg\* /s >NUL'
      say '- example Multiline messages copied from .\doc\msg'
    end
    else
      say 'X scr\ subdirectory cannot be created'
  end

if ( SysFileTree( '.\log', ft ) = 0 ) then
  if ( ft.0 = 0 ) then do
    if ( SysMkDir( 'log' ) = 0 ) then
      say '- log\ subdirectory created'
    else
      say 'X log\ subdirectory cannot be created'
  end

say 'Creating IPS folder:'
call SysMoveObject '<IPSFOLDER>', '<WP_DESKTOP>'
call SysDestroyObject '<IPSFOLDER>'
if SysCreateObject( 'WPFolder', ipsvers, '<WP_DESKTOP>',,
                    'OBJECTID=<IPSFOLDER>;ICONFILE='cur_dir'\bin\ico\ipsfldr1.ico;ICONNFILE=1,'cur_dir'\bin\ico\ipsfldr2.ico;ICONVIEWPOS=25 50 50 25;BACKGROUND='cur_dir'\doc\img\firering.jpg,,,I' ) then do
  say '- IPS folder created'
end

say 'Creating IPS objects:'

call SysDestroyObject '<STARTIPS>'
if SysCreateObject( 'WPProgram', 'Start IPS daemon', '<IPSFOLDER>',,
                    'OBJECTID=<STARTIPS>;EXENAME='cur_dir'\bin\startos2.cmd;PARAMETERS=DoStartup;STARTUPDIR='cur_dir';ICONFILE='cur_dir'\bin\ico\ips.ico;MINIMIZED=YES' ) then
  say '- Startup object created'

if ( SysFileTree( '*', ft, 'DS' ) = 0 ) then do
  do curd=1 to ft.0
    parse value ft.curd with date time size attr name
    name = strip( name )
    call SysSetObjectData name, 'ICONFILE='cur_dir'\bin\ico\ipsfldr1.ico;ICONNFILE=1,'cur_dir'\bin\ico\ipsfldr2.ico;BACKGROUND='cur_dir'\doc\img\firering.jpg,,,I;ALWAYSSORT=YES;SHOWALLINTREEVIEW=YES;DEFAULTVIEW=TREE'
  end curd
end

call SysDestroyObject '<IPSPWD>'
if SysCreateObject( 'WPProgram', 'Make crypted password', '<IPSFOLDER>',,
                    'OBJECTID=<IPSPWD>;EXENAME='cur_dir'\bin\pwd2.exe;PARAMETERS=[Type password to crypt:];STARTUPDIR='cur_dir';ICONFILE='cur_dir'\bin\ico\ips.ico;NOAUTOCLOSE=YES' ) then
  say '- Password object created'

longname = 'Configure IPS'
call SysPutEA cur_dir'\cfg', '.LONGNAME', 'FDFF'x || d2c( length( longname )) || '00'x || longname
if SysCreateShadow( cur_dir'\cfg', '<IPSFOLDER>'  ) then
  say '- Configuration shadow folder created'

longname = 'RexxHook scripts'
call SysPutEA cur_dir'\scr', '.LONGNAME', 'FDFF'x || d2c( length( longname )) || '00'x || longname
if SysCreateShadow( cur_dir'\scr', '<IPSFOLDER>'  ) then
  say '- RexxHook script shadow folder created'

longname = 'Documentation'
call SysPutEA cur_dir'\doc', '.LONGNAME', 'FDFF'x || d2c( length( longname )) || '00'x || longname
if SysCreateShadow( cur_dir'\doc', '<IPSFOLDER>'  ) then
  say '- IPS documentation shadow folder created'

call SysOpenObject '<IPSFOLDER>', 'ICON', 0
